import java.util.Scanner;

public class Fibonacci
{
  public static void main(String [] args)
  {
    Scanner scan = new Scanner(System.in);
    System.out.println("Enter the number N");
    int N = scan.nextInt();
    
    // recursive calculation - noticeably slow at about N = 40
    for (int n = 0; n <= N; n++)
      System.out.println("F[" + n + "] = " + fib(n));
    
    // iterative calculation
    for (int n = 0; n <= N; n++)
      System.out.println("F[" + n + "] = " + fibonacci(n));
  }
  
  // recursive method
  private static int fib(int n)
  {
    if (n <= 1)
      return n;
    else
      return fib(n - 1) + fib(n - 2);
  }
  
  // iterative method
  private static int fibonacci(int n)
  {
    int fNminus2 = 0, fNminus1 = 1;
    int fN = 0;
    if (n <= 1)
      return n;
    for (int i = 2; i <= n; i++)
    {
      fN = fNminus1 + fNminus2;  // fN = f[n-1] + f[n-2]
      fNminus2 = fNminus1;       // f[n-2] = f[n-1] 
      fNminus1 = fN;             // f[n-1] = f[n]
    }
    return fN;
  }
}